<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once(JPATH_SITE.'/components/com_joomd/libraries/core.php');

class JoomdFields extends Joomd	{
	
	var $_error = null;
	var $_plugin = null;
	var $_type = 1;
	
	function __construct($plugin = null, $typeid=null)
	{
		
		$this->_db =& JFactory::getDBO();
		$this->_plugin = $plugin;
		$this->getType($typeid);
		$this->getPlugin();
				
	}
	
	//returns the typeid of the plugin of current object if not then default
	function getType($typeid)
	{
		
	/*	if(!$this->_type and $this->_plugin)	{
			$query = 'select id from #__joomd_types where plugin = ( select id from #__joomd_plugins where view = "'.$this->_plugin.'" limit 1 )';
			$this->_db->setQuery( $query );
			$this->_type = $this->_db->loadResult();
		}
		if(!$this->_type)
			$this->_type = 1;
		*/
		
		//changed for multiple instances of same plugin
		$this->_type = empty($typeid)?JRequest::getInt('typeid', 1):$typeid;
		
		
	}
	
	//returns the view of the plugin of current object if not then entry is selected
	function getPlugin()
	{
		
		if($this->_type and !$this->_plugin)	{
			$query = 'select view from #__joomd_plugins where id = ( select plugin from #__joomd_types where id = '.$this->_type.' limit 1 )';
			$this->_db->setQuery( $query );
			$this->_plugin = $this->_db->loadResult();
		}
		if(!$this->_plugin)
			$this->_plugin = 'entry';
		
	}
	
	function checkType()
	{
		
		$mainframe =& JFactory::getApplication();
		
		$query = 'select count(*) from #__joomd_types as t join #__joomd_plugins as p on (t.plugin=p.id and p.view = '.$this->_db->Quote($this->_plugin).') where t.id = '.$this->_type;
		$this->_db->setQuery( $query );
		$count = $this->_db->loadResult();
		
		if(!$count)
			Joomd::redirect('index.php?option=com_joomd&view=category', JText::_('TYPENOTRECOGNIZED'));
		
	}
	
	//to get the errors if occurred
	function getError()
	{
		
		return $this->_error;
		
	}
	
	//to set the errors if occur
	function setError($error)
	{
	
		$this->_error = $error;
		
	}
	
	function makecore($id)
	{
		
		$field = $this->getField($id);
		
		if(!$field->id)	{
			$this->setError(JText::_('FIELDNOTEXISTS'));
			return false;
		}
		
		$name = 'field_'.$field->id;
		
		
		//check whether it already exists
		$query = 'show fields from #__joomd_'.$this->_plugin.' LIKE '.$this->_db->Quote($name);
		$this->_db->setQuery( $query );
		$exists = $this->_db->loadObject();
		
		//if already in plugin table then skip
		if(empty($exists))	{
		
			$query = 'alter table #__joomd_'.$this->_plugin.' add column `'.$name.'` ';
			
			switch($field->type)
			{
				
				case 7:
				$query .= 'date not null';
				break;
				
				case 5:
				case 6:
				$query .= 'text';
				break;
				
				default:
				$query .= ' varchar (255) not null';
				break;
				
			}
			
			$this->_db->setQuery( $query );
			
			if(!$this->_db->query())	{
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			
		}
		
		//move field data
		$query = 'select * from #__joomd_'.$this->_plugin.'_fielddata where fieldid = '.$field->id;
		$this->_db->setQuery( $query );
		$values = $this->_db->loadObjectList();
		
		foreach($values as $value)	{
			
			if(!empty($value->value))	{
			
				$insert = new stdClass();
				
				$insert->id = $value->itemid;
				$insert->$name = $value->value;
				
				if(!$this->_db->updateObject('#__joomd_'.$this->_plugin, $insert, 'id'))	{
					$this->setError($this->_db->stderr());
					return false;
				}
			
			}
			
		}
		
		//delete if any record exists
		if(count($values))	{
			$query = 'delete from #__joomd_'.$this->_plugin.'_fielddata where fieldid = '.$field->id;
			$this->_db->setQuery( $query );
			$this->_db->query();
		}
		
		//update the core setting in field
		$query = 'update #__joomd_field set core = 1 where id = '.$field->id;
		$this->_db->setQuery( $query );
		$this->_db->query();
		
		return true;
		
	}
	
	function updatecore($id)
	{
		
		$field = $this->getField($id);
		
		if(!$field->id)	{
			$this->setError(JText::_('FIELDNOTEXISTS'));
			return false;
		}
		
		$name = 'field_'.$field->id;
		
		$query = 'show fields from #__joomd_'.$this->_plugin.' LIKE '.$this->_db->Quote($name);
		$this->_db->setQuery( $query );
		$exists = $this->_db->loadObject();
		
		if(empty($exists))	{
			$this->setError(JText::sprintf('SDOESNEXIT', $field->name));
			return false;
		}
		
		$query = 'alter table #__joomd_'.$this->_plugin.' change `'.$name.'` `'.$name.'` ';
		
		switch($field->type)
		{
			
			case 7:
			$query .= 'date not null';
			break;
			
			case 5:
			case 6:
			$query .= 'text';
			break;
			
			default:
			$query .= ' varchar (255) not null';
			break;
			
		}
		
		$this->_db->setQuery( $query );
		
		if(!$this->_db->query())	{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		return true;
		
	}
	
	function removecore($id)
	{
		
		$field = $this->getField($id);
		
		if(!$field->id)	{
			$this->setError(JText::_('FIELDNOTEXISTS'));
			return false;
		}
		
		$name = 'field_'.$field->id;
		
		$query = 'show fields from #__joomd_'.$this->_plugin.' LIKE '.$this->_db->Quote($name);
		$this->_db->setQuery( $query );
		$exists = $this->_db->loadObject();
		
		if(!empty($exists))	{
			
			$query = 'select count( * ) from #__joomd_field where core = 1';
			$this->_db->setQuery( $query );
			$count = $this->_db->loadResult();
			
			if($count < 2)	{
				$this->setError( JText::_( 'TITOCF', true ) );
				return false;
			}
			
			$query = 'select id, '.$name.' from #__joomd_'.$this->_plugin;
			$this->_db->setQuery( $query );
			$values = $this->_db->loadObjectList();
			
			foreach($values as $value)	{
				
				if(!empty($value->$name))	{
				
					$query = 'select count( * ) from #__joomd_'.$this->_plugin.'_fielddata where itemid = '.$value->id.' and fieldid = '.$field->id;
					$this->_db->setQuery( $query );
					$count = $this->_db->loadResult();
					
					if($count)	{
						
						$query = 'update #__joomd_'.$this->_plugin.'_fielddata set value = '.$this->_db->Quote($value->$name).' where itemid = '.$value->id.' and fieldid = '.$field->id;
					
					}
					
					else	{
						
						$query = 'insert into #__joomd_'.$this->_plugin.'_fielddata (itemid, fieldid, value) values ( '.$value->id.', '.$field->id.', '.$this->_db->Quote($value->$name).' )';
						
					}
					
					$this->_db->setQuery( $query );
					
					if(!$this->_db->query())	{
						$this->setError($this->_db->getErrorMsg());
						return false;
					}
				
				}
				
			}
			
			$query = 'alter table #__joomd_'.$this->_plugin.' drop `'.$name.'`';
		
			$this->_db->setQuery( $query );
			
			if(!$this->_db->query())	{
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			
			
		}
		
		$query = 'update #__joomd_field set core = 0 where id = '.$field->id;
		$this->_db->setQuery( $query );
		$this->_db->query();
		
		return true;
		
	}
	
	function delete($cid)
	{	

		if (count( $cid ) < 1) {
			$this->setError( JText::_( 'SAFTDEL', true ) );
			return false;
		}
		
		JArrayHelper::toInteger( $cid );
		
		foreach ($cid as $id)
		{
			
			$field = $this->getField($id);
			
			if($field->core)	{
				
				$name = 'field_'.$id;
					
				$query = 'show fields from #__joomd_'.$this->_plugin.' LIKE '.$this->_db->Quote($name);
				$this->_db->setQuery( $query );
				$exists = $this->_db->loadObject();
				
				if(!empty($exists))	{
				
					$query = 'select count( * ) from #__joomd_field where core = 1';
					$this->_db->setQuery( $query );
					$count = $this->_db->loadResult();
					
					if($count < 2)	{
						$this->setError( JText::_( 'TITCFDEL', true ) );
						return false;
					}
					else	{
						$query = 'alter table #__joomd_'.$this->_plugin.' drop `'.$name.'`';
		
						$this->_db->setQuery( $query );
						
						if(!$this->_db->query())	{
							$this->setError($this->_db->getErrorMsg());
							return false;
						}
					}
				
				}
				
			}
			
			$query = 'delete from #__joomd_field where id = '.$id;
			$this->_db->setQuery( $query );
			
			if(!$this->_db->query())	{
				
				$this->setError($this->_db->getErrorMsg());
				return false;
				
			}

		}

		return true;
	}
		
	function getField($id, $params = array())
	{
		
		settype($id, 'int');
		
		$mainframe =& JFactory::getApplication();
		$user =& JFactory::getUser();
		
		$params['published'] = isset($params['published'])?$params['published']:false;
		$params['access'] = isset($params['access'])?$params['access']:true;
		
		$query = 'select * from #__joomd_field where id = '.$id;
		
		if($params['published'])
			$query .= ' and published = 1';
		
		if($params['access'])	{
			
			if(version_compare(JVERSION, '1.6.0', 'lt'))
				$query .= ' and access <= '.(int)$user->aid;
			else
				$query .= ' and access in ('.implode(',', $user->getAuthorisedViewLevels()).')';
		
		}
		
		$this->_db->setQuery( $query );
		$field = $this->_db->loadObject();
		
		if(empty($field))	{
			
			JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomd'.DS.'tables');
			$field =& JTable::getInstance('field', 'Table');
			
			$field->load(0);
			
		}
		
		return $field;
		
	}
	
	function getFields($params = array())
	{
		
		$mainframe =& JFactory::getApplication();
		$user =& JFactory::getUser();
		
		$params['itemid'] = isset($params['itemid'])?(int)$params['itemid']:0;
		$params['cats'] = isset($params['cats'])?$params['cats']:null;
		$params['core'] = isset($params['core'])?$params['core']:false;
		$params['category'] = isset($params['category'])?$params['category']:false;
		$params['list'] = isset($params['list'])?$params['list']:false;
		$params['detail'] = isset($params['detail'])?$params['detail']:false;
		$params['search'] = isset($params['search'])?$params['search']:false;
		$params['type'] = isset($params['type'])?$params['type']:false;
		$params['published'] = isset($params['published'])?$params['published']:false;
		$params['orderby'] = isset($params['orderby'])?$params['orderby']:'ordering';
		$params['orderdir'] = isset($params['orderdir'])?$params['orderdir']:'asc';
		$params['access'] = isset($params['access'])?$params['access']:true;
		$params['ids'] = isset($params['ids'])?$params['ids']:false;
		
		settype($params['cats'], 'array');
		
		$key = array_search(0, $params['cats']);
		
		if($key !== false)
			unset($params['cats'][$key]);
			
		JArrayHelper::toInteger( $params['cats'] );
		
		$where = array();
		
		$query = 'select fieldid from #__joomd_tnf where typeid = '.$this->_type;
		$this->_db->setQuery( $query );
		$ids = (array)$this->_db->loadResultArray();
		
		$where[] = count($ids)?('id in ('.implode(', ', $ids).')'):'id=0';
		
		if($params['access'])	{
			
			if(version_compare(JVERSION, '1.6.0', 'lt'))
				$where[] = 'access <= '.(int)$user->aid;
			else
				$where[] = 'access in ('.implode(',', $user->getAuthorisedViewLevels()).')';
		
		}
		
		if($params['itemid'])	{
			
			$query = 'select catid from #__joomd_'.$this->_plugin.'_cat where itemid ='.$params['itemid'];
			$this->_db->setQuery( $query );
			$cats = (array)$this->_db->loadResultArray();
			
			if(!count($cats))
				$cats = array(0);
			
			$where[] = 'id in ( select fieldid from #__joomd_cnf where catid in ( '.implode(', ', $cats).' ) )';
		}
		
		if(count($params['cats']))	{
					
			$query = 'select fieldid from #__joomd_cnf where catid in ('.implode(', ', $params['cats']).')';
			$this->_db->setQuery( $query );
			$ids = (array)$this->_db->loadResultArray();
			
			$where[] = count($ids)?'id in ('.implode(', ', $ids).')':'id = 0';
			
		}
		
		if($params['published'])	{
			$where[] = 'published = 1';
		}
		
		if($params['ids'])	{
			
			if(is_array($params['ids']))	{
				JArrayHelper::toInteger( $params['ids'] );
				
				if(count($params['ids']))
					$where[] = 'id in ('.implode(',', $params['ids']).')';
				
			}
			else
				$where[] = 'id = '.(int)$params['ids'];
		}
		
		if($params['type'])	{
			
			if(is_array($params['type']))	{
				JArrayHelper::toInteger( $params['cats'] );
				
				if(count($params['type']))
					$where[] = 'type in ('.implode(',', $params['type']).')';
				
			}
			else
				$where[] = 'type = '.(int)$params['type'];
		}
		
		if($params['core'] === 1)
			$where[] = 'core = 1';
		elseif($params['core'] === 0)
			$where[] = 'core = 0';
		
		if($params['category'])	{
			
			$where[] = 'category = 1';
			
		}
		
		if($params['list'])	{
			
			$where[] = 'list = 1';
			
		}
		
		if($params['detail'])	{
			
			$where[] = 'detail = 1';
			
		}
		
		if($params['search'])	{
			
			$where[] = 'search = 1';
			
			$where[] = 'type in (1, 2, 3, 4, 7, 8, 9)';
			
		}
		
		$filter = count($where)?' where '.implode(' and ', $where):'';
		
		$query = 'select * from #__joomd_field '.$filter.' order by '.$params['orderby'].' '.$params['orderdir'];
		$this->_db->setQuery( $query );
		$fields = (array)$this->_db->loadObjectList();
		
		return $fields;
		
	}
	
	function getCoreFields($params = array())
	{
			
		$params['published'] = isset($params['published'])?$params['published']:false;
		$params['core'] = 1;
		
		$fields = $this->getFields($params);
		
		$this->checkcore($fields);
		
		return $fields;
		
	}
	
	function checkcore($fields = array())
	{
		
		$fields = (array)$fields;
		
		if(!count($fields))	{
			
			$fields = $this->getFields();
			
		}
		
		foreach($fields as $field)	{
			
			if(is_object($field))
				$id = $field->id;
			else
				$id = (int)$field;
			
			$name = 'field_'.$id;
			
			$query = 'show fields from #__joomd_'.$this->_plugin.' LIKE '.$this->_db->Quote($name);
			$this->_db->setQuery( $query );
			$exists = $this->_db->loadObject();
			
			if(empty($exists))	{
				
				if(!$this->makecore($id))
					return false;
				
			}
			
		}
		
	}
	
	function get_firstfield($params = array())
	{
			
		$params['itemid'] = isset($params['itemid'])?(int)$params['itemid']:0;
		$params['published'] = isset($params['published'])?$params['published']:null;
		$params['type'] = isset($params['type'])?$params['type']:false;
		$params['core'] = isset($params['core'])?$params['core']:1;
		$params['cats'] = isset($params['cats'])?$params['cats']:null;
		
		settype($params['cats'], 'array');
		
		$key = array_search(0, $params['cats']);
		
		if($key !== false)
			unset($params['cats'][$key]);
			
		JArrayHelper::toInteger( $params['cats'] );
		
		$query = 'select fieldid from #__joomd_tnf where typeid = '.$this->_type;
		$this->_db->setQuery( $query );
		$ids = (array)$this->_db->loadResultArray();
		
		$where = array();
		
		$where[] = count($ids)?('id in ('.implode(', ', $ids).')'):'id=0';
		
		if($params['itemid'])	{
			
			$query = 'select catid from #__joomd_'.$this->_plugin.'_cat where itemid ='.$params['itemid'];
			$this->_db->setQuery( $query );
			$params['cats'] = (array)$this->_db->loadResultArray();
			
			if(!count($params['cats']))
				$params['cats'] = array(0);

		}
		
		if(count($params['cats']))	{
					
			$query = 'select fieldid from #__joomd_cnf where catid in ('.implode(', ', $params['cats']).')';
			$this->_db->setQuery( $query );
			$ids = (array)$this->_db->loadResultArray();
			
			$where[] = count($ids)?'id in ('.implode(', ', $ids).')':'id = 0';
			
		}
		
		if($params['core'] === 1)
			$where[] = 'core = 1';
		elseif($params['core'] === 0)
			$where[] = 'core = 0';
			
		if($params['published'])
			$where[] = 'published = 1';
			
		if($params['type'])	{
			
			if(is_array($params['type']))	{
				JArrayHelper::toInteger( $params['cats'] );
				
				if(count($params['type']))
					$where[] = 'type in ('.implode(',', $params['type']).')';
				
			}
			else
				$where[] = 'type = '.(int)$params['type'];
		}
		
		$filter = count($where)?' where '.implode(' and ', $where):'';
		
		$query = 'select id from #__joomd_field '.$filter.' order by ordering asc limit 1';
		$this->_db->setQuery( $query );
		$fieldid = $this->_db->loadResult();
		
		$field = $this->getField($fieldid);
		
		return $field;
		
	}
	
	function loadformfields($itemid, $params=array())
	{
		
		$params['validation'] = isset($params['validation'])?$params['validation']:true;
		$params['access'] = isset($params['access'])?$params['access']:true;
		
		settype($itemid, 'int');
		
		$fields = $this->getFields($params);
		
		if(count($fields))	{
			
		$mainframe =& JFactory::getApplication();
		
		if($mainframe->isSite())
			$listtable = 'edittable';
		else
			$listtable = 'admintable';
			
		$document =& JFactory::getDocument();
		
		$tooltip = Joomdui::getTooltip();
		$tooltip->initialize('.hasTip');
		
		$lnEnd = $document->_getLineEnd();
		$tab = $document->_getTab();
		
		$body = '<table class="'.$listtable.'">
					<tbody>'.$lnEnd;
				
		for($i=0;$i<count($fields);$i++)	{
			
			$body .= '<tr><td class="key">'.$fields[$i]->name.'</td>'.$lnEnd;
			$body .= '<td colspan="2">'.$this->loadformfield($fields[$i]->id, $itemid, $params).'</td></tr>'.$lnEnd;
			
		}
		
		$body .= '</tbody>
				</table>';
		
		$head='';
		
		if($params['validation'])	{
			
			$head = '<script type="text/javascript">'.$lnEnd.'
			
				'.$tab.'function validatefields()	{'.$lnEnd;
			
			for($i=0;$i<count($fields);$i++)	{
				
				$head .= $this->loadfieldvalidation($fields[$i]->id, $params).$lnEnd;
				
			}
			
			$head .= 'return true;'.$lnEnd.' }'.$lnEnd.'</script>'.$lnEnd;
			
		}
				
		foreach($document->_script as $k=>$v)
			$head .= $tab.'<script type="'.$k.'">'.$v.'</script>'.$lnEnd;
			
		foreach($document->_custom as $custom) {
			$head .= $tab.$custom.$lnEnd;
		}
		
				
		$html = $head.$body;
		
		return $html;
		
		
		}
		
		else
			return null;
				
		
	}
	
	function loadformfield($fieldid, $itemid, $params=array())
	{
		
		settype($itemid, 'int');
		
		$params['icon'] = isset($params['icon'])?$params['icon']:true;
		$params['form'] = isset($params['form'])?$params['form']:'adminform';
		
		$view = JRequest::getVar('view', '');
		
		$field = $this->getField($fieldid);
		
		if(!$field->id)
			return null;
		
		$value = $this->getfieldvalue($itemid, $field->id);
		
		$custom = json_decode($field->custom);
		
		switch($field->type)
		{
			
			case 1:
			case 8:
				$html = '<input type="text" name="field_'.$field->id.'" id="field_'.$field->id.'" class="'.$field->cssclass.'" value="'.$value.'" />';
			break;
			
			case 2:
			
				$options = explode("\n", $field->options);
				
				$html = '';
				
				foreach($options as $option)	{
					$option = trim($option);
					$html .= '<input type="radio" name="field_'.$field->id.'" id="field_'.$field->id.'" class="'.$field->cssclass.'" value="'.$option.'"';
					if($option == $value)
						$html .= ' checked="checked"';
					$html .= '/> '.$option;
					
				}
								
			break;
			
			case 3:
			
				$options = explode("\n", $field->options);
				
				$html = '';
				
				$values = explode('|', $value);
				
				foreach($options as $option)	{
					$option = trim($option);
					$html .= '<input type="checkbox" name="field_'.$field->id.'[]" id="field_'.$field->id.'" class="'.$field->cssclass.'" value="'.$option.'"';
					if(in_array($option, $values))
						$html .= ' checked="checked"';
					$html .= '/> '.$option;
					
				}
								
			break;
			
			case 4:
				
				$multiple = isset($custom->multiple)?$custom->multiple:0;
				$options = explode("\n", $field->options);
				
				$suf = ($multiple==1)?'[]':'';
				
				$html = '<select name="field_'.$field->id.$suf.'" id="field_'.$field->id.'"';
				if($multiple)
					$html .= ' multiple="multiple"';
				$html .= '>';
				
				$values = explode('|', $value);
				
				foreach($options as $option)	{
					$option = trim($option);
					$html .= '<option value="'.$option.'"';
					if(in_array($option, $values))
						$html .= ' selected="selected"';
					$html .= '>'.$option.'</option>';
					
				}
				
				$html .= '</select>';
								
			break;
			
			case 5:
			
				$rows = isset($custom->rows)?$custom->rows:8;
				$cols = isset($custom->cols)?$custom->cols:75;
			
				$html = '<textarea name="field_'.$field->id.'" id="field_'.$field->id.'" class="'.$field->cssclass.'"';
				if($rows)
					$html .= ' rows="'.$rows.'"';
				if($cols)
					$html .= 'cols="'.$cols.'"';
				$html .= '>'.$value.'</textarea>';
				
			break;
			
			case 6:
			
				$rows = isset($custom->rows)?$custom->rows:null;
				$cols = isset($custom->cols)?$custom->cols:null;
				
				$editor = Joomdui::getEditor();
				$editor->initialize( 'form[name=\''.$params['form'].'\'] #field_'.$field->id );
				$html = '<textarea name="field_'.$field->id.'" id="field_'.$field->id.'" class="'.$field->cssclass.'"';
				if($rows)
					$html .= ' rows="'.$rows.'"';
				if($cols)
					$html .= 'cols="'.$cols.'"';
				$html .= '>'.$value.'</textarea>';
								
			break;
			
			case 7:
				$datepicker = Joomdui::getDatepicker();
				
				$year = isset($custom->year)?$custom->year:false;
				$month = isset($custom->month)?$custom->month:false;
				
				$datepicker->initialize('form[name=\''.$params['form'].'\'] #field_'.$field->id, array('changeMonth'=>$month, 'changeYear'=>$year));
				
				$value = ($value == '0000-00-00')?null:$value;
					
				
				$html = '<input type="text" name="field_'.$field->id.'" id="field_'.$field->id.'" class="'.$field->cssclass.'" value="'.$value.'" />';
			break;
			
			case 9:
				$value = empty($value)?'http://':$value;
				$html = '<input type="text" name="field_'.$field->id.'" id="field_'.$field->id.'" class="'.$field->cssclass.'" value="'.$value.'" />';
			break;
			
			case 10:
			case 11:
			case 12:
				$multiple = isset($custom->multiple)?$custom->multiple:null;
				$maxsize = isset($custom->maxsize)?$custom->maxsize:null;
				$filetypes = isset($custom->filetypes)?$custom->filetypes:null;
				$thumb_width = isset($custom->thumb_width)?$custom->thumb_width:null;
				$thumb_height = isset($custom->thumb_height)?$custom->thumb_height:null;
				$thumb = isset($custom->thumb)?$custom->thumb:null;
				
				$suf = ($multiple==1)?'[]':'';
				
				$array = array('fieldname'=>'field_'.$field->id.$suf, 'buttontext'=>JText::_('ADD').' '.$field->name);
				
				if($multiple == 1)
					$array['maxNumberOfFiles'] = 'undefined';
					
				if(!empty($value))	{
					
					$files = array();
					
					$vals = explode('|', $value);
					
					foreach($vals as $val)	{
						$file=null;
						if(!empty($val) and is_file(JPATH_SITE.'/images/joomd/'.$val))	{
							$file->name = $val;
							
							if(is_file(JPATH_SITE.'/images/joomd/thumbs/'.$val))
								$file->thumbnail_url = JURI::root().'images/joomd/thumbs/'.$val;
							elseif(is_file(JPATH_SITE.'/images/joomd/'.$val) and $field->type == 10)
								$file->thumbnail_url = JURI::root().'images/joomd/'.$val;
							elseif(!empty($thumb) and $field->type <> 10)
								$file->thumbnail_url = $thumb;
															
							$file->delete_url = 'index.php?option=com_joomd&view='.$view.'&task=delete_custom&id='.$itemid.'&fieldid='.$field->id.'&filename='.$file->name.'&abase=1';
							$files[] = $file;
						}
						
					}
					
					$array['files'] = $files;
					
				}
				
				Joomdui::uploadfile('form[name=\''.$params['form'].'\'] #field_'.$field->id, $array);
				
				$html = '<div id="field_'.$field->id.'"></div>';
				
			break;
			
			case 13:
				$html = '<input type="text" name="field_'.$field->id.'" id="field_'.$field->id.'" class="'.$field->cssclass.'" value="'.$value.'" />';
			break;
			
			default:
			$html = JText::_('UNKCOLTYP');
			break;
			
		}
		
		if($params['icon'])	{
		
			if($field->required)
				$html .= '  <em class="required">*</em>';
			
			if(!empty($field->text))
				$html .= ' <span class="hasTip info" title="'.$field->text.'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" alt="info" align="absbottom" /></span>';
			
		}
			
		return $html;
		
	}
	
	function loadfieldvalidation($fieldid, $params=array())	{
			
		$params['form'] = isset($params['form'])?$params['form']:'adminform';
		
		$field = $this->getField($fieldid);
		
		if(!$field->id)
			return null;
		
		$custom = json_decode($field->custom);
		
		$js = '';
		
		switch($field->type)
		{
			
			case 1:
			case 5:
			case 6:
			case 13:
				if($field->required)
					$js .= 'if($jd(\'form[name="'.$params['form'].'"] input[name="field_'.$field->id.'"]\').val() == "") { alert("'.JText::sprintf('SIAREQF', $field->name).'"); return false; }';
					
			break;
			
			case 2:
			
				if($field->required)
					$js .= 'if($jd(\'form[name="'.$params['form'].'"] input[name="field_'.$field->id.'"]:checked\').length == 0) { alert("'.JText::sprintf('SIAREQF', $field->name).'"); return false; }';
								
			break;
			
			case 3:
			
				if($field->required)
					$js .= 'if($jd(\'form[name="'.$params['form'].'"] input[name="field_'.$field->id.'[]"]:checked\').length == 0) { alert("'.JText::sprintf('SIAREQF', $field->name).'"); return false; }';
								
			break;
			
			case 4:
				
				$multiple = isset($custom->multiple)?$custom->multiple:null;
				
				$suf = ($multiple==1)?'[]':'';
				
				if($field->required)
					$js .= 'if($jd(\'form[name="'.$params['form'].'"] select#field_'.$field->id.' :selected\').length == 0) { alert("'.JText::sprintf('SIAREQF', $field->name).'"); return false; }';
								
			break;
			
			case 7:
				
				if($field->required)
					$js .= 'if($jd(\'form[name="'.$params['form'].'"] input[name="field_'.$field->id.'"]\').val() == "" || $jd(\'form[name="'.$params['form'].'"] input[name="field_'.$field->id.'"]\').val() == "0000-00-00") { alert("'.JText::sprintf('SIAREQF', $field->name).'"); return false; }';
				
				$js .= 'if($jd(\'form[name="'.$params['form'].'"] input[name="field_'.$field->id.'"]\').val() != "" && !isDate($jd(\'form[name="'.$params['form'].'"] input[name="field_'.$field->id.'"]\').val())) { alert("'.JText::sprintf('PLSENTVALID', $field->name).'"); return false; }';
				
			break;
			
			case 8:
				
				if($field->required)
					$js .= 'if($jd(\'form[name="'.$params['form'].'"] input[name="field_'.$field->id.'"]\').val() == "") { alert("'.JText::sprintf('SIAREQF', $field->name).'"); return false; }';
					
				$js .= 'var reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;';
				
				$js .= 'if($jd(\'form[name="'.$params['form'].'"] input[name="field_'.$field->id.'"]\').val() != "" && reg.test($jd(\'form[name="'.$params['form'].'"] input[name="field_'.$field->id.'"]\').val()) == false) {
					alert( "'.JText::sprintf('PLSENTVALID', $field->name).'" );
					return false;
				}';
								
			break;
			
			case 9:
			
				if($field->required)
					$js .= 'if($jd(\'form[name="'.$params['form'].'"] input[name="field_'.$field->id.'"]\').val() == "" || $jd(\'form[name="'.$params['form'].'"] input[name="field_'.$field->id.'"]\').val() == "http://") { alert("'.JText::sprintf('SIAREQF', $field->name).'"); return false; }';
			
			break;
			
			case 10:
			case 11:
			case 12:
			/*	if($field->required)	{
					
					$js .= 'if(files_to_upload.length==0) { alert("'.JText::sprintf('%s is a required field', $field->name).'"); return false; }
					else	{
						
						for(var i=0;i<files_to_upload.length;i++)	{
							
							alert(files_to_upload[i].files.length);
							
							if(files_to_upload[i].files.length < 1)	{
								alert("'.JText::sprintf('%s is a required field', $field->name).'");
								return false;
							}
							
						}
						
					}';
				
				} */
				
			break;
			
		}
			
		return $js;
		
	}
	
	function displayfieldvalue($itemid, $fieldid, $short=false)
	{
		
		$field = $this->getField($fieldid);
		
		if(!$field->id)
			return null;
		
		$custom = json_decode($field->custom);
		
		$value = $this->getfieldvalue($itemid, $field->id);
		
		if(empty($value))
			return null;
		
		switch($field->type)
		{
			
			case 3:
			case 4:
			
			return str_replace('|', ', ', $value);
			
			break;
			
			case 5:
			
			if($short)
				return substr($value, 0, 100);
			else
				return $value;
			
			break;
			
			case 6:
			
			if($short)
				return substr($value, 0, 100);
			else	{
				$content = isset($custom->content)?$custom->content:0;
				$layout = JRequest::getVar('layout', '');
				if($layout == 'detail' and $content)	{
					$dispatcher	=& JDispatcher::getInstance();
					$item->id = $field->id;
					$item->title = $field->name;
					$item->text = $value;
					JPluginHelper::importPlugin('content');
					$results = $dispatcher->trigger('onPrepareContent', array (& $item, & $params, 0));
					$value = $item->text;
				}
				return $value;
			}
			
			break;
			
			case 7:
			
				if($value == "0000-00-00")
					return null;
				else
					return $value;
			
			break;
			
			case 8:

				return '<a href="mailto:'.$value.'">'.$value.'</a>';
			
			break;
			
			case 9:

				if($value == 'http://' or $value == 'https://')
					return null;
				else
					return '<a href="'.$value.'" target="_blank">'.$value.'</a>';
				
			break;
			
			case 10:
			
			$default = isset($custom->default)?$custom->default:null;
			$val = explode('|', $value);
			
			if($short)	{
			
				if(!empty($val[0]) and is_file(JPATH_SITE.'/images/joomd/thumbs/'.$val[0]))
					return '<img src="'.JURI::root().'images/joomd/thumbs/'.$val[0].'" alt="'.$field->name.'" />';
				elseif(!empty($val[0]) and is_file(JPATH_SITE.'/images/joomd/'.$val[0]))
					return '<img src="'.JURI::root().'images/joomd/'.$val[0].'" alt="'.$field->name.'" width="50" />';
				elseif(!empty($default))
					return '<img src="'.$default.'" alt="'.$field->name.'" width="50" />';
				else
					return null;
			
			}
			else	{
												
				$display = array();
				
				foreach($val as $v)	{
					
					if(!empty($v) and is_file(JPATH_SITE.'/images/joomd/'.$v))
						$display[] = '<img src="'.JURI::root().'images/joomd/'.$v.'" alt="'.$field->name.'" border="0" />';
					elseif(!empty($default))
						$display[] = '<img src="'.$default.'" alt="'.$field->name.'" border="0" />';
					
				}
				
				
				if(count($display))	{
				
					$html = '<ul>
								<li>'.implode("</li>\n<li>", $display).'</li>
							</ul>';
							
					return $html;
					
				}
				
				return null;
			
			}
			
			break;
			
			case 11:
			
			$thumb = isset($custom->thumb)?$custom->thumb:null;
			$val = explode('|', $value);
			
			if($short)	{
				
				if(!empty($val[0]) and is_file(JPATH_SITE.'/images/joomd/'.$val[0]))	{
					if(empty($thumb))
						return '<a href="'.JURI::root().'images/joomd/'.$val[0].'" target="_blank">'.$val[0].'</a>';
					else
						return '<a href="'.JURI::root().'images/joomd/'.$val[0].'" target="_blank"><img src="'.$thumb.'" alt="'.$field->name.'" /></a>';
				}
				
			}
			
			else	{
			
				$display = array();
				
				foreach($val as $v)	{
					
					if(!empty($v) and is_file(JPATH_SITE.'/images/joomd/'.$v))	{
						if(empty($thumb))
							$display[] = '<a href="'.JURI::root().'images/joomd/'.$v.'" target="_blank">'.$v.'</a>';
						else
							$display[] = '<a href="'.JURI::root().'images/joomd/'.$v.'" target="_blank"><img src="'.$thumb.'" alt="'.$field->name.'" /></a>';
					}				
				
				}
				
				if(count($display))	{
				
					$html = '<ul>
							<li>'.implode("</li>\n<li>", $display).'</li>
						</ul>';
								
					return $html;
					
				}
			
			}
			
			return null;
			
			break;
			
			case 12:
							
				$height = isset($custom->height)?$custom->height:400;
				$width = isset($custom->width)?$custom->width:600;
				$thumb = isset($custom->thumb)?$custom->thumb:null;
				
				$url = JURI::root().'images/joomd/'.$value;
				
				$ext = strrchr($value, '.');
				
				if($ext == '.mp4' or $ext == '.flv')	{
					
					$doc = JFactory::getDocument();
					$doc->addScript('components/com_joomd/assets/js/jwplayer.js');
					
					$js = '<script>jwplayer("field_'.$field->id.'").setup({
					  flashplayer: "'.JURI::root().'components/com_joomd/assets/player.swf",
					  file: "'.$url.'",
					  height: 400,
					  width: 550,
					  controlbar: "bottom"';
					  
					 if(!empty($thumb) and is_file($thumb))
						$js .= ', image='.$thumb;
							
					 $js .= '});</script>';
										
					$html = '<div id="field_'.$field->id.'"></div>';
					
					return $html.$js;
					
				/*	$html = '<object id="player" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" name="player" width="'.$width.'" height="'.$height.'"> 
						<param name="movie" value="'.JURI::root().'components/com_joomd/assets/player.swf" /> 
						<param name="allowfullscreen" value="true" /> 
						<param name="allowscriptaccess" value="always" /> 
						<param name="flashvars" value="file='.$url;
						if(!empty($thumb) and is_file($thumb))
							$html .= '&image='.$thumb;
						$html .= '" /> 
						<embed 
							type="application/x-shockwave-flash"
							id="player2"
							name="player2"
							src="'.JURI::root().'components/com_joomd/assets/player.swf" 
							width="'.$width.'" 
							height="'.$height.'"
							allowscriptaccess="always" 
							allowfullscreen="true"
							flashvars="file='.$url;
							if(!empty($thumb) and is_file($thumb))
								$html .= '&image='.$thumb;
							$html .= '" /> 
					</object>';
					*/
				}
				else	{
					
					$html = '<object classid="CLSID:6BF52A52-394A-11d3-B153-00C04F79FAA6" type="application/x-oleobject" style="width: '.$width.'px; height: '.$height.'px;">
								<param name="URL" value="'.$url.'">
								<param name="stretchToFit" value="1">
								<param name="wmode" value="transparent">
								<param name="showControls" value="1">
								<param name="scale" value="exactfit">
								<param name="showStatusBar" value="0">
								<param name="animationAtStart" value="1">
								<param name="autoStart" value="0">
								<param name="enableFullScreenControls" value="0">
								<embed src="'.$url.'" style="width: '.$width.'px; height: '.$height.'px;" scale="exactfit" autostart="0" animationatstart="1" enablefullscreencontrols="0" type="application/x-mplayer2" wmode="transparent">
							</object>';
					
				}
				
				return $html;
			
			break;
			
			case 13:
							
				$height		= isset($custom->height)?$custom->height:400;
				$width		= isset($custom->width)?$custom->width:600;
				$fullscreen = isset($custom->fullscreen)?$custom->fullscreen:0;
				
				$url = 'http://www.youtube.com/embed/'.$value.'?rel=0';
				
			/*	$doc = JFactory::getDocument();
					$doc->addScript('components/com_joomd/assets/js/jwplayer.js');
					
					$js = '<script>jwplayer("field_'.$field->id.'").setup({
					  flashplayer: "'.JURI::root().'components/com_joomd/assets/player.swf",
					  file: "'.$url.'",
					  height: 400,
					  width: 550,
					  controlbar: "bottom", provider:"youtube"';
					  
					 if(!empty($thumb) and is_file($thumb))
						$js .= ', image='.$thumb;
							
					 $js .= '});</script>';
										
					$html = '<div id="field_'.$field->id.'"></div>';
					
					return $html.$js;*/
				
				$html = '<iframe width="'.$width.'" height="'.$height.'" src="'.$url.'" frameborder="0"';
				
				if($fullscreen)
					$html .= ' allowfullscreen';
				
				$html .= '></iframe>';
				
				return $html;
			
			break;
			
			default:
			return $value;
			break;
			
			
		}
		
	}
	
	function getfieldvalue($itemid, $fieldid, $short=false)
	{
		
		if(!$itemid or !$fieldid)
			return null;
		
		settype($itemid, 'int');
		
		$field = $this->getField($fieldid);
		
		if($field->core)	{
			
			$this->checkcore($field->id);
			
			$query = 'select field_'.$fieldid.' from #__joomd_'.$this->_plugin.' where id = '.$itemid;
			
		}
		
		else	{
			
			$query = 'select value from #__joomd_'.$this->_plugin.'_fielddata where itemid = '.$itemid.' and fieldid = '.$field->id;
			
		}
		
		$this->_db->setQuery( $query );
		$value = $this->_db->loadResult();
		
		switch($field->type)
		{
			
			case 7:
			if($value == '0000-00-00')
				$value = null;
			break;
			
			case 9:
			if($value == 'http://' or $value == 'https://')
				$value = null;
			break;
			
		}
		
		return $value;
		
	}
	
	function emptyfieldvalue($itemid, $fieldid)
	{
		
		$field = $this->getField($fieldid);
		
		if(!$field->id)	{
			$this->setError(JText::_('FIELDNOTEXISTS'));
			return false;
		}
		
		settype($itemid, 'int');
		
		if($field->core)	{
		
			$query = 'update #__joomd_'.$this->_plugin.' set field_'.$field->id.' = "" where id = '.$itemid;
		
		}
		
		else	{
			
			$query = 'delete from #__joomd_'.$this->_plugin.'_fielddata where itemid = '.$itemid.' and fieldid = '.$field->id;
			
		}
		
		$this->_db->setQuery( $query );
			
		if(!$this->_db->query())	{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		return true;
		
	}
	
	function updatefieldvalue($itemid, $fieldid, $value)
	{
		
		$field = $this->getField($fieldid);
		
		if(!$field->id)	{
			$this->setError(JText::_('FIELDNOTEXISTS'));
			return false;
		}
		
		settype($itemid, 'int');
				
		if($field->core)	{
		
			$query = 'update #__joomd_'.$this->_plugin.' set field_'.$fieldid.' = '.$this->_db->Quote($value).' where id = '.$itemid;
		
		}
		
		else	{
			
			$query = 'update #__joomd_'.$this->_plugin.'_fielddata set value = '.$this->_db->Quote($value).' where itemid = '.$itemid.' and fieldid = '.$field->id;
			
		}
		
		$this->_db->setQuery( $query );
			
		if(!$this->_db->query())	{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		return true;
		
	}
	
	function checkField($itemid, $fieldid)
	{
		
		$field = $this->getField($fieldid);
		
		if(!$field->id)	{
			$this->setError(JText::_('FIELDNOTEXISTS'));
			return false;
		}
		
		if(!$field->required)	{
		
			if(in_array($field->type, array(10, 11, 12)))	{
				if(!isset($_FILES['field_'.$field->id]))
					return true;			
			}
			else	{
				if(!isset($_POST['field_'.$field->id]))
					return true;
			}
		
		}
		
		$pvalue = $this->getfieldvalue($itemid, $fieldid);
		
		$view = JRequest::getVar('view', '');
		
		$custom = json_decode($field->custom);
		
		settype($itemid, 'int');
		
		$return = true;
		
		switch($field->type)
		{
			
			case 1:
			case 2:
			case 5:
			$value = JRequest::getVar('field_'.$field->id, '');
			
			if($field->required && empty($value))	{
				$this->setError(JText::sprintf('SIAREQF', $field->name));
				$return = false;
			}
			
			break;
			
			case 3:
			$value = implode('|', (array)JRequest::getVar('field_'.$field->id, array(), 'post', 'array'));
			
			if($field->required && empty($value))	{
				$this->setError(JText::sprintf('SIAREQF', $field->name));
				$return = false;
			}
			
			break;
			
			case 4:
			
			$multiple = isset($custom->multiple)?$custom->multiple:null;
			
			if($multiple == 1)
				$value = implode('|', (array)JRequest::getVar('field_'.$field->id, array(), 'post', 'array'));
			else
				$value = JRequest::getVar('field_'.$field->id, '');
			
			if($field->required && empty($value))	{
				$this->setError(JText::sprintf('SIAREQF', $field->name));
				$return = false;
			}
			
			break;
			
			case 6:
			$value = JRequest::getVar('field_'.$field->id, '', 'post', 'string', JREQUEST_ALLOWRAW);
			
			if($field->required && empty($value))	{
				$this->setError(JText::sprintf('SIAREQF', $field->name));
				$return = false;
			}
			
			break;
			
			case 7:
			$value = JRequest::getVar('field_'.$field->id, '');
			
			$value = ($value=='0000-00-00')?null:$value;
			
			if($field->required && empty($value))	{
				$this->setError(JText::sprintf('SIAREQF', $field->name));
				$return = false;
			}
			
			break;
			
			case 8:
			$value = JRequest::getVar('field_'.$field->id, '', 'post');
			
			if($field->required && empty($value))	{
				$this->setError(JText::sprintf('SIAREQF', $field->name));
				$return = false;
			}
			
			if(!empty($value) && !preg_match("/^[_\.0-9a-zA-Z-]+@([0-9a-zA-Z][0-9a-zA-Z-]+\.)+[a-zA-Z]{2,6}$/i", $value))	{
				$this->setError(JText::sprintf('PLSENTVALID', $field->name));
				$return = false;
			}
			
			break;
			
			case 9:
			$value = JRequest::getVar('field_'.$field->id, '');
			
			if($value == 'http://' or $value == 'https:://')
				$value = null;
			
			if($field->required && empty($value))	{
				$this->setError(JText::sprintf('SIAREQF', $field->name));
				$return = false;
			}
			
			break;
			
			case 10:
			case 11:
			case 12:
			
			$multiple = isset($custom->multiple)?$custom->multiple:null;
			$maxsize = isset($custom->maxsize)?$custom->maxsize*1000:null;
			$filetypes = isset($custom->filetypes)?$custom->filetypes:null;
			$thumb_width = isset($custom->thumb_width)?$custom->thumb_width:null;
			$thumb_height = isset($custom->thumb_height)?$custom->thumb_height:null;
			$thumb = isset($custom->thumb)?$custom->thumb:null;
			
			$files = array();
			
			$allowed = explode(',', str_replace(' ', '', $filetypes));
				
			$time = time();
					
			jimport('joomla.filesystem.file');
			
			$image = JRequest::getVar('field_'.$field->id, null, 'FILES', 'array');
			
			if($multiple == 1)	{
				
				$values = empty($pvalue)?array():explode('|', $pvalue);
				
				if(count($image['name']))	{
					
					foreach($image['name'] as $i=>$v)	{
						$file=null;
						$file->error = 'empty file';
						
						$image_name    = str_replace(' ', '', JFile::makeSafe($image['name'][$i]));
						$image_tmp     = $image["tmp_name"][$i];
						
						$ext = strrchr($image_name, '.');
						
						if(!in_array($ext, $allowed))	{
							$file->error = JText::_('THISTYPNALL'.$ext);
							array_push($files, $file);
							return $files;
						}
						
						if(!empty($maxsize) && filesize($image_tmp) > $maxsize)	{
							$file->error = JText::_('FSEXMAXFS');
							array_push($files, $file);
							return $files;
						}
						
						if(!move_uploaded_file($image_tmp, JPATH_SITE.'/images/joomd/'.$time.$image_name))	{
							$file->error = JText::_('SIMDCNUP');
							array_push($files, $file);
							return $files;				
						}
						
						if(!(empty($thumb_width) and empty($thumb_height)) and $field->type == 10)	{
							
							if(Joomd::create_scaled_image(JPATH_SITE.'/images/joomd/'.$time.$image_name, array('max_width'=>$thumb_width, 'max_height'=>$thumb_height)) === false)	{
								$file->error = JText::_('SRYTHUMCNCRE');
								array_push($files, $file);
								return $files;
							}
							else
								$file->thumbnail_url = JURI::root().'images/joomd/thumbs/'.$time.$image_name;
							
						}
						elseif($field->type == 10)
							$file->thumbnail_url = JURI::root().'images/joomd/'.$time.$image_name;
						elseif(!empty($thumb) and $field->type <> 10)
							$file->thumbnail_url = $thumb;
						
						$file->name = $time.$image_name;
						
						array_push($values, $file->name);
						
						$file->delete_url = 'index.php?option=com_joomd&view='.$view.'&task=delete_custom&id='.$itemid.'&fieldid='.$field->id.'&filename='.$file->name.'&abase=1';
						$file->delete_type = 'POST';
						
						unset($file->error);
					
						array_push($files, $file);
					
					}
					
					$value = implode('|', (array)$values);
					
					$return = $files;
				
				}
				
				elseif($field->required && empty($pvalue) && ( count($values) < 1 || !is_file(JPATH_SITE.'/images/joomd/'.$values[0])))	{
					$file->error = JText::sprintf('SREQ', $field->name);
						
					array_push($files, $file);
					
					$value = null;
				
					$return = $files;
				}
				
				else	{
					$return = array();
					$value = null;
				}
			
			}
			
			else	{
				
				$image_name    = str_replace(' ', '', JFile::makeSafe($image['name']));
				
				if(!empty($image_name))	{
				
					$image_tmp     = $image["tmp_name"];
					
					$ext = strrchr($image_name, '.');
					
					if(!in_array($ext, $allowed))	{
						$file->error = JText::_('THISTYPNALL');
						array_push($files, $file);
						return $files;
					}
					
					if(!empty($maxsize) && filesize($image_tmp) > $maxsize)	{
						$file->error = JText::_('FSEXMAXFS');
						array_push($files, $file);
						return $files;
					}
					
					if(!move_uploaded_file($image_tmp, JPATH_SITE.'/images/joomd/'.$time.$image_name))	{
						$file->error = JText::_('SIMDCNUP');
						array_push($files, $file);
						return $files;				
					}
					
					if(!(empty($thumb_width) and empty($thumb_height)) and $field->type == 10)	{
							
						if(Joomd::create_scaled_image(JPATH_SITE.'/images/joomd/'.$time.$image_name, array('max_width'=>$thumb_width, 'max_height'=>$thumb_height)) === false)	{
							$file->error = JText::_('SRYTHUMCNCRE');
							array_push($files, $file);
							return $files;
						}
						else
							$file->thumbnail_url = JURI::root().'images/joomd/thumbs/'.$time.$image_name;
						
					}
					elseif($field->type == 10)
						$file->thumbnail_url = JURI::root().'images/joomd/'.$time.$image_name;
					elseif(!empty($thumb) and $field->type <> 10)
						$file->thumbnail_url = $thumb;
					
					$post['field_'.$field->id] = $file->name = $time.$image_name;
									
					$file->delete_url = 'index.php?option=com_joomd&view='.$view.'&task=delete_custom&id='.$itemid.'&fieldid='.$field->id.'&filename'.$file->name.'&abase=1';
					$file->delete_type = 'POST';
					
					array_push($files, $file);
					
					$value = implode('|', (array)$post['field_'.$field->id]);
				
					$return = $files;
				
				}
				elseif($field->required && empty($pvalue) && !is_file(JPATH_SITE.'/images/joomd/'.$pvalue))	{
					$file->error = JText::sprintf('SREQ', $field->name);
					
					array_push($files, $file);
				
					$value = null;
				
					$return = $files;
					
				}
				else	{
					$return = array();
					$value = null;
				}
				
			}
						
			break;
			
			case 13:
			$value = JRequest::getVar('field_'.$field->id, '');
			
			if($field->required && empty($value))	{
				$this->setError(JText::sprintf('SIAREQF', $field->name));
				$return = false;
			}
						
			if(strpos($value, 'v=') !== false)	{
				$pos1 = strpos($value, 'v=')+2;
				$pos2 = strpos($value, '&', $pos1);
				if($pos2 === false)
					$value = substr($value, $pos1);
				else
					$value = substr($value, $pos1, $pos2-$pos1);
				
			}
			elseif(strpos($value, 'youtu.be/') !== false)	{
				$pos1 = strpos($value, 'youtu.be/')+9;
				
				$value = substr($value, $pos1);
				
			}
			
			break;
			
		}
		
		JRequest::setVar('field_'.$field->id, $value, 'post');
		
		return $return;
		
	}
	
	function saveFields($itemid, $fields)
	{
		
		foreach($fields as $field)	{
			
			if(isset($_POST['field_'.$field->id]))	{
							
				if(!$this->saveField($itemid, $field->id))
					return false;
				
			}
			
		}
		
		return true;
		
	}
	
	function saveField($itemid, $fieldid)
	{
		
		$field = $this->getField($fieldid);
		
		if(!$field->id)	{
			$this->setError(JText::_('FIELDNOTEXISTS'));
			return false;
		}
		
		settype($itemid, 'int');
		
		$value = JRequest::getVar('field_'.$fieldid, null, 'post', 'string', JREQUEST_ALLOWRAW);		
	
		if($field->core)	{
			
			$this->checkcore($field->id);
			
			$query = 'update #__joomd_'.$this->_plugin.' set field_'.$field->id.' = '.$this->_db->Quote($value).' where id = '.$itemid;
			
		}
		else	{
			
			$q = 'select count( * ) from #__joomd_'.$this->_plugin.'_fielddata where itemid = '.$itemid.' and fieldid = '.$field->id;
			
			$this->_db->setQuery( $q );
			$count = $this->_db->loadResult();
			
			if($count)
				$query = 'update #__joomd_'.$this->_plugin.'_fielddata set value = '.$this->_db->Quote($value).' where itemid = '.$itemid.' and fieldid = '.$fieldid;
			else
				$query = 'insert into #__joomd_'.$this->_plugin.'_fielddata values('.$itemid.', '.$field->id.', '.$this->_db->Quote($value).')';
			
		}
		
		$this->_db->setQuery( $query );
		
		if(!$this->_db->query())	{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
				
		return true;
		
	}
	
	function loadfieldoptions($id, $type)
	{
		
		$row = $this->getField($id);
		
		$custom = json_decode($row->custom);
		
		$html = '<script type="text/javascript">$jd(".tooltip").tooltip({showBody:"::"});';
        
        if($type==2 or $type==3 or $type==4)
        	$html .= 'function validateoptions() { if($jd(\'textarea[name="options"]\').val() == "") { alert("'.JText::_('PLSENTSOMVALOPT').'"); return false; } return true; }';
        
		$html .= '</script>';
		
		switch($type)
		{
			
			case 2:
			case 3:
				$html .= '<fieldset class="adminform">

				<legend>Field Options</legend>
				
				<table class="admintable">
					<tbody>
					<tr>
					<td class="key">'.JText::_('OPTION').':</td>
					<td colspan="2"><textarea name="options" id="options" rows="5" cols="40">'. $row->options.'</textarea> <em class="required">*</em> <span class="tooltip" title="'.JText::_('FIELDOPTIONTT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="'. JText::_('INFO').'" align="top" /></span>
					</td>
				  </tr>
				  </tbody>
					</table>
					
				</fieldset>';
			break;
			
			case 4:
			
				$multiple = isset($custom->multiple)?$custom->multiple:null;
				
				$html .= '<fieldset class="adminform">

				<legend>Field Options</legend>
				
				<table class="admintable">
					<tbody><tr>
					<td class="key">'.JText::_('OPTION').':</td>
					<td colspan="2"><textarea name="options" id="options" rows="5" cols="40">'. $row->options.'</textarea> <em class="required">*</em> <span class="tooltip" title="'.JText::_('FIELDOPTIONTT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="'. JText::_('INFO').'" align="top" /></span>
					</td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('MULTIPLE').':</td>
					<td colspan="2"><input type="radio" name="custom[multiple]" id="custommultiple" value="1"';
					if($multiple == 1)
						$html .= ' checked="checked"';
					$html .= '
					> '. JText::_('YS').' <input type="radio" name="custom[multiple]" id="custommultiple" value="0"';
					if($multiple == 0)
						$html .= ' checked="checked"';
					$html .= '> '. JText::_('NS').'
					</td>
				  </tr>
				  </tbody>
					</table>
					
				</fieldset>';
			
			break;
			
			case 5:
			
				$rows = isset($custom->rows)?$custom->rows:7;
				$cols = isset($custom->cols)?$custom->cols:50;
				
				$html .= '<fieldset class="adminform">

				<legend>Field Options</legend>
				
				<table class="admintable">
					<tbody><tr>
					<td class="key">'.JText::_('ROW').':</td>
					<td colspan="2"><input type="text" name="custom[rows]" id="customrows" value="'.$rows.'" size="3" /></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('COLS').':</td>
					<td colspan="2"><input type="text" name="custom[cols]" id="customcols" value="'.$cols.'" size="3" /></td>
				  </tr>
				  </tbody>
					</table>
					
				</fieldset>';
				  
			break;
			
			case 6:
			
				$rows = isset($custom->rows)?$custom->rows:7;
				$cols = isset($custom->cols)?$custom->cols:50;
				$content = isset($custom->content)?$custom->content:0;
				
				$html .= '<fieldset class="adminform">

				<legend>Field Options</legend>
				
				<table class="admintable">
					<tbody><tr>
					<td class="key">'.JText::_('ROW').':</td>
					<td colspan="2"><input type="text" name="custom[rows]" id="customrows" value="'.$rows.'" size="3" /></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('COLS').':</td>
					<td colspan="2"><input type="text" name="custom[cols]" id="customcols" value="'.$cols.'" size="3" /></td>
				  </tr>
				   <tr>
					<td class="key">'.JText::_('ENABLECONPLG').':</td>
					<td colspan="2"><input type="radio" name="custom[content]" id="customcontent1" value="1"';
					if($content == 1)
						$html .= ' checked="checked"';
					$html .= '
					> '. JText::_('YS').' <input type="radio" name="custom[content]" id="customcontent0" value="0"';
					if($content == 0)
						$html .= ' checked="checked"';
					$html .= '> '. JText::_('NS').'
					</td>
				  </tr>
				  </tbody>
					</table>
					
				</fieldset>';
				  
			break;
			
			case 7:
			
				$month = isset($custom->month)?$custom->month:null;
				$year = isset($custom->year)?$custom->year:null;
				
				$html .= '<fieldset class="adminform">

				<legend>Field Options</legend>
				
				<table class="admintable">
					<tbody><tr>
					<td class="key">'.JText::_('SMONDROP').':</td>
					<td colspan="2"><input type="radio" name="custom[month]" id="custommonth1" value="1"';
					if($month == 1)
						$html .= ' checked="checked"';
					$html .= '/> '.JText::_('YS').' <input type="radio" name="custom[month]" id="custommonth0" value="0"';
					if($month == 0)
						$html .= ' checked="checked"';
					$html .= ' /> '.JText::_('NS').'</td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('SYDD').':</td>
					<td colspan="2"><input type="radio" name="custom[year]" id="customyear1" value="1"';
					if($year == 1)
						$html .= ' checked="checked"';
					$html .= ' /> '.JText::_('YS').' <input type="radio" name="custom[year]" id="customyear0" value="0"';
					if($year == 0)
						$html .= ' checked="checked"';
					$html .= '/> '.JText::_('NS').'</td>
				  </tr>
				  </tbody>
					</table>
					
				</fieldset>';
			
			break;
			
			case 10:
			
				$multiple = isset($custom->multiple)?$custom->multiple:null;
				$maxsize = isset($custom->maxsize)?$custom->maxsize:null;
				$filetypes = isset($custom->filetypes)?$custom->filetypes:null;
				$thumb_width = isset($custom->thumb_width)?$custom->thumb_width:null;
				$thumb_height = isset($custom->thumb_height)?$custom->thumb_height:null;
				$default = isset($custom->default)?$custom->default:null;
			
				$html .= '<fieldset class="adminform">

				<legend>Field Options</legend>
				
				<table class="admintable">
					<tbody>
				  <tr>
					<td class="key">'.JText::_('MULTIPLE').':</td>
					<td colspan="2"><input type="radio" name="custom[multiple]" id="custommultiple1" value="1"';
					if($multiple == 1)
						$html .= ' checked="checked"';
					$html .= '
					> '. JText::_('YS').' <input type="radio" name="custom[multiple]" id="custommultiple0" value="0"';
					if($multiple == 0)
						$html .= ' checked="checked"';
					$html .= '> '. JText::_('NS').'
					</td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('ALLOWEDTYPES').':</td>
					<td colspan="2"><input type="text" name="custom[filetypes]" id="customfiletypes" value="'.$filetypes.'" size="40" /> <span class="tooltip" title="'.JText::_('FIELDFILEALLOWEDTT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="'. JText::_('INFO').'" align="top" /></span></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('MAXALLOWEDSIZE').':</td>
					<td colspan="2"><input type="text" name="custom[maxsize]" id="custommaxsize" value="'.$maxsize.'" size="10" /> <span class="tooltip" title="'.JText::_('FIELDFILESIZETT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="'. JText::_('INFO').'" align="top" /></span></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('THUMBWIDTH').':</td>
					<td colspan="2"><input type="text" name="custom[thumb_width]" id="customthumb_width" value="'.$thumb_width.'" size="3" /> <span class="tooltip" title="'.JText::_('FIELDTHUMBWIDTHTT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="'. JText::_('INFO').'" align="top" /></span></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('THUMBHEIGHT').':</td>
					<td colspan="2"><input type="text" name="custom[thumb_height]" id="customthumb_height" value="'.$thumb_height.'" size="3" /> <span class="tooltip" title="'.JText::_('FIELDTHUMBHEIGHTTT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="'. JText::_('INFO').'" align="top" /></span></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('DEFAULT').':</td>
					<td colspan="2"><input type="text" name="custom[default]" id="customdefault" value="'.$default.'" size="40" /> <span class="tooltip" title="'.JText::_('FIELDFILETT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="'. JText::_('INFO').'" align="top" /></span></td>
				  </tr>
				  </tbody>
					</table>
					
				</fieldset>';
			
			break;
			
			case 11:
			
				$multiple = isset($custom->multiple)?$custom->multiple:null;
				$maxsize = isset($custom->maxsize)?$custom->maxsize:null;
				$filetypes = isset($custom->filetypes)?$custom->filetypes:null;
				$thumb = isset($custom->thumb)?$custom->thumb:null;
			
				$html .= '<fieldset class="adminform">

				<legend>Field Options</legend>
				
				<table class="admintable">
					<tbody>
				  <tr>
					<td class="key">'.JText::_('MULTIPLE').':</td>
					<td colspan="2"><input type="radio" name="custom[multiple]" id="custommultiple1" value="1"';
					if($multiple == 1)
						$html .= ' checked="checked"';
					$html .= '
					> '. JText::_('YS').' <input type="radio" name="custom[multiple]" id="custommultiple0" value="0"';
					if($multiple == 0)
						$html .= ' checked="checked"';
					$html .= '> '. JText::_('NS').'
					</td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('ALLOWEDTYPES').':</td>
					<td colspan="2"><input type="text" name="custom[filetypes]" id="customfiletypes" value="'.$filetypes.'" size="40" /> <span class="tooltip" title="'.JText::_('FIELDFILEALLOWEDTT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="'. JText::_('INFO').'" align="top" /></span></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('MAXALLOWEDSIZE').':</td>
					<td colspan="2"><input type="text" name="custom[maxsize]" id="custommaxsize" value="'.$maxsize.'" size="10" /> <span class="tooltip" title="'.JText::_('FIELDFILESIZETT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="'. JText::_('INFO').'" align="top" /></span></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('THUMNAIL').':</td>
					<td colspan="2"><input type="text" name="custom[thumb]" id="customthumb" value="'.$thumb.'" size="40" /> <span class="tooltip" title="'.JText::_('FIELDFILETHUMB').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="'. JText::_('INFO').'" align="top" /></span></td>
				  </tr>
				  </tbody>
					</table>
					
				</fieldset>';
			
			break;
			
			case 12:
			
				$maxsize = isset($custom->maxsize)?$custom->maxsize:null;
				$filetypes = isset($custom->filetypes)?$custom->filetypes:null;
				$width = isset($custom->width)?$custom->width:null;
				$height = isset($custom->height)?$custom->height:null;
				$thumb = isset($custom->thumb)?$custom->thumb:null;
			
				$html .= '<fieldset class="adminform">

				<legend>Field Options</legend>
				
				<table class="admintable">
					<tbody>
					<tr>
					<td class="key">'.JText::_('WIDTH').':</td>
					<td colspan="2"><input type="text" name="custom[width]" id="customwidth" value="'.$width.'" size="3" /> <span class="tooltip" title="'.JText::_('FIELDVIDEOWIDTH').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="info" align="top" /></span></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('HEIGHT').':</td>
					<td colspan="2"><input type="text" name="custom[height]" id="customheight" value="'.$height.'" size="3" /> <span class="tooltip" title="'.JText::_('FIELDVIDEOHEIGHT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="info" align="top" /></span></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('ALLOWEDTYPES').':</td>
					<td colspan="2"><input type="text" name="custom[filetypes]" id="customfiletypes" value="'.$filetypes.'" size="40" /> <span class="tooltip" title="'.JText::_('FIELDVIDEOALLOWEDTT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="info" align="top" /></span></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('MAXALLOWEDSIZE').':</td>
					<td colspan="2"><input type="text" name="custom[maxsize]" id="custommaxsize" value="'.$maxsize.'" size="10" /> <span class="tooltip" title="'.JText::_('FIELDFILESIZETT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="info" align="top" /></span></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('THUMNAIL').':</td>
					<td colspan="2"><input type="text" name="custom[thumb]" id="customthumb" value="'.$thumb.'" size="40" /> <span class="tooltip" title="'.JText::_('FIELDFILETHUMB').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="info" align="top" /></span></td>
				  </tr>
				  </tbody>
					</table>
					
				</fieldset>';
			
			break;
			
			case 13:
			
				$fullscreen = isset($custom->fullscreen)?$custom->fullscreen:null;
				$width = isset($custom->width)?$custom->width:null;
				$height = isset($custom->height)?$custom->height:null;
			
				$html .= '<fieldset class="adminform">

				<legend>Field Options</legend>
				
				<table class="admintable">
					<tbody>
					<tr>
					<td class="key">'.JText::_('WIDTH').':</td>
					<td colspan="2"><input type="text" name="custom[width]" id="customwidth" value="'.$width.'" size="3" /> <span class="tooltip" title="'.JText::_('FIELDVIDEOWIDTH').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="info" align="top" /></span></td>
				  </tr>
				  <tr>
					<td class="key">'.JText::_('HEIGHT').':</td>
					<td colspan="2"><input type="text" name="custom[height]" id="customheight" value="'.$height.'" size="3" /> <span class="tooltip" title="'.JText::_('FIELDVIDEOHEIGHT').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="info" align="top" /></span></td>
				  </tr>';/*
				  <tr>
					<td class="key">'.JText::_('ALLOWFULLSCREEN').':</td>
					<td colspan="2"><input type="radio" name="custom[fullscreen]" id="customfullscreene1" value="1"';
					if($fullscreen == 1)
						$html .= ' checked="checked"';
					$html .= '
					> '. JText::_('YS').' <input type="radio" name="custom[fullscreen]" id="customfullscreen0" value="0"';
					if($fullscreen == 0)
						$html .= ' checked="checked"';
					$html .= '> '. JText::_('NS').' <span class="tooltip" title="'.JText::_('FIELDVIDEOFULLSCREEN').'"><img src="'.JURI::root().'components/com_joomd/assets/images/icon-16-info.png" border="0" alt="info" align="top" /></span>
					</td>
				  </tr>*/
				  $html .= '</tbody>
				</table>
					
				</fieldset>';
						
			break;
			
			default:
			break;
			
		}
		
		return $html;
		
	}
	
}